/*
    debug.cpp
    $Id: debug.cpp,v 1.1 2010/03/08 08:01:30 daichi Exp $

*/
#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include "debug.h"
#define  DEBUG_FILE	"log.debug"

static FILE *dp = NULL;

static void
dp_init ()
{
	if ((dp = fopen(DEBUG_FILE, "w")) == NULL)
	{
		fprintf(stderr, "dp_init: can't open debugging output: %s\n",
			DEBUG_FILE);
		exit(1);
	}
}

int
dprintf (const char *fmt, ...)
{
	int n;
	va_list ap;
	
	if (dp == NULL) dp_init ();
	
	va_start(ap, fmt);
	n = vfprintf(dp, fmt, ap);
	fflush(dp);
	va_end(ap);
	return n;
}

void
dprint_table (double *table, int n)
{
	int i;
	dprintf("table [%d]:", n);
	for (i = 0; i < n; i++)
		dprintf(" %.5lf", table[i]);
	dprintf("\n");
}

void
dprint_table (int *table, int n)
{
	int i;
	dprintf("table [%d]:", n);
	for (i = 0; i < n; i++)
		dprintf(" %d", table[i]);
	dprintf("\n");
}

FILE *
dprintfp ()
{
	if (dp == NULL) dp_init ();
	return dp;
}



	
