/*
 *    log.cpp
 *    $Id: log.cpp,v 1.1 2010/03/11 17:22:38 daichi Exp $
 *
 */
#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <unistd.h>
#include <ctime>
#include "log.h"
#include "util.h"

static FILE *lp = NULL;

logging::logging (char *argv[], char *file)
{
	char *s, hostname [BUFSIZ];
	time_t timer;

	if ((lp = fopen (strconcat(file, "/log"), "w")) == NULL)
	{
		perror("fopen");
		exit(1);
	}
	time(&timer);
	gethostname(hostname, BUFSIZ);

	fprintf(lp, "init   :");
	while (s = *argv++) fprintf(lp, " %s", s);
	fprintf(lp, "\n");
	fprintf(lp, "host   : %s\n", hostname);
	fprintf(lp, "start  : %s", ctime(&timer));
	fprintf(lp, "--------\n");
	fflush(lp);
}

logging::~logging ()
{
	time_t timer;
	time(&timer);
	
	fprintf(lp, "--------\n");
	fprintf(lp, "finish : %s", ctime(&timer));
	fclose(lp);
}

static void
init_log ()
{
	if ((lp = fopen (DEFAULT_LOG_FILE, "w")) == NULL)
	{
		perror("fopen");
		exit(1);
	}
}

int
lprintf (const char *fmt, ...)
{
	int n;
	va_list ap;
	
	if (lp == NULL) init_log ();
	
	va_start(ap, fmt);
	n = vfprintf(lp, fmt, ap);
	va_end(ap);
	fflush(lp);
	return n;
}

FILE *
lprintfp ()
{
	if (lp == NULL) init_log ();
	return lp;
}

#if 0
int
main (int argc, char *argv[])
{
	logging start(argv, "hoge");
	int i;

	lprintf("hogeran %s\n", argv[0]);

}
#endif
