/*
    table.h
    The Latent Words Language Model.
    $Id: table.h,v 1.3 2010/03/15 07:28:17 daichi Exp $

*/
#ifndef _TABLE_H_
#define _TABLE_H_
#include <vector>
#include <ext/hash_map>

using namespace std;
using namespace __gnu_cxx;

typedef hash_map <long, int> val_hash;

struct LWLM;

struct TransTable {
	int L;
	double alpha;
	val_hash counts;
	vector<int> total;

	bool init (int lexicon);
	int  count (int hidden, int observed);
	void add_count (int hidden, int observed);
	void sub_count (int hidden, int observed);
	double probability (int hidden, int observed);
	bool save (char *file, LWLM *lwlm);
	bool load (char *file, LWLM *lwlm);
	TransTable (double alpha);
	
};

#endif

